<%@ include file="includes/jspheader.jsp" %>
<%@ include file="includes/jspencoding.jsp" %>

<%@ page import="java.util.logging.*" %>
<%@ page import="com.esko.webcenter.log.*" %>

<%@ page import="com.esko.webcenter.jsp.*" %>
<%@ page import="com.esko.webcenter.cache.*" %>
<%@ page import="com.esko.webcenter.exceptions.*" %>
<%@ page import="com.esko.webcenter.src.root.view.DocVersionView" %>
<%@ page import="com.esko.webcenter.src.root.ApprovalStatusDB" %>
<%@ page import="com.esko.webcenter.src.root.*"%>
<%@ page import="java.util.Hashtable" %>
<%@ page import="java.util.Vector" %>
<%@ page import="java.sql.Timestamp" %>
<%@ page import="com.esko.webcenter.src.root.view.*" %>

<%@ page import="com.esko.webcenter.jsp.pagelist.PageListUtils" %>

<%
System.out.println("getapprovalstate.jsp: "+request.getRemoteHost()+" ("+request.getRemoteAddr()+")");
String errStr = "";
String message = "";
done:
{
error:
{
	String ProjectID = request.getParameter("projectid");
	String DocID = request.getParameter("docid");
	String DocVersionID = request.getParameter("docversionid");
	String pageNumber = request.getParameter("pageno");
	String LoginID = LoginMgr.getLoginMgr(session).getLoginID();
	String UserID = LoginMgr.getLoginMgr(session).getLoginUserID();
	
	if (UserID==null ||
		LoginID==null ||
		ProjectID==null ||
		DocVersionID==null ||
		DocID==null)
	{
		errStr = "Internal error: missing parameters";
		break error;
	}

	try {

		String UserLang = LoginMgr.getLoginMgr(session).getLangKey(session);
	
		// load EJBs
		Approval approvalEJB = DBTMUtils.findBean(response, session, Approval.class);
		if (approvalEJB == null)
		{
			errStr = "Error: cannot connect to approval bean - make sure application server is running";
			break error;
		}

		ProjectTM projectTM = DBTMUtils.findBean(response, session, ProjectTM.class);
		if (projectTM == null)
		{
			errStr = "Error: cannot connect to project bean - make sure application server is running";
			break error;
		}
		
		UserTM userTM  = DBTMUtils.findBean(response, session, UserTM.class);
		if (userTM== null)
		{
			errStr = "Error: cannot connect to userTM bean - make sure application server is running";
			break error;
		}
		
		ComplexApprovalTM complexApprovalTM = DBTMUtils.findBean(response, session, ComplexApprovalTM.class);
		if (complexApprovalTM == null)
		{
			errStr = "Error: cannot connect to complexApprovalTM bean - make sure application server is running";
			break error;
		}
		
		WCProject curProject = new WCProject(projectTM.findById(LoginID, ProjectID));
		
		String approvalTypeId = null; 
		String appComment = null ;
		
		DocVersionApprovalInfo docVerInfo = null ;
		int docVersionOffset = -1 ;
		
		PageListPageProperties pageListPageProperties = null ;
		DocumentMgrTM docMgtTM = DBTMUtils.findBean(response, session, DocumentMgrTM.class);
		DocVersion docVersion = docMgtTM.findDocVersionById(LoginID, DocVersionID);		
		if (docVersion.getDocTypeID().equalsIgnoreCase(DocTypeDB.DocTypeIDValues.PageList ) )
		{
			// do page list actions : create page list ejb and save the approval info 
			PageListTM pagelistTM = DBTMUtils.findBean(response, session, PageListTM.class);
		
			// get the cached value of the pagelist
			Vector pages =	PageListUtils.getPageList( response, session, DocID  );
			
			int pagenr = new Integer(pageNumber).intValue() ;
			if ((pages!=null) && (pages.size() >= pagenr )  ) 
			{	
				PageListPageDocVersionView pageListPageDocVersionView = (PageListPageDocVersionView) pages.elementAt(pagenr-1 );		
				pageListPageProperties = pagelistTM.loadPageListPageProperties(LoginID, pageListPageDocVersionView.getDocVersion().getObjectID(), pageListPageDocVersionView.getPageListPageProperties().getVersionPageIndex() ) ; 
				approvalTypeId = pageListPageProperties.getApprovalStatus();
			}
			else 
			{
				errStr = "pagelist pages out of range. Page size is " + ((pages!=null)?pages.size():0) + ", required page number is : " + pagenr;
				break error;			
			}			
			
			DocVersion docVersion2 = DBUtils.getHighestDocVersion(response, session, docMgtTM,  DocID) ;
			DocVersionID = docVersion2.getObjectID() ;
			docVerInfo = approvalEJB.findDocVersionApprovalInfoByDocVersionId(LoginID, DocVersionID);			
			
			// get the docversionpage 
			PageListDocVersionProperties pageListDocVersionProperties =pagelistTM.loadPageListDocVersionProperties( LoginID, DocVersionID);
			docVersionOffset = pageListDocVersionProperties.getIndex() ;
		}
		else 
		{
			docVerInfo = approvalEJB.findDocVersionApprovalInfoByDocVersionId(LoginID, DocVersionID);		
		}

		if (docVerInfo == null)
		{
			// approval info not found - probably no approval required, 
			// set the hide control to 1 
			message = "<status>" ;
			message += "<value>0</value>"; 
			message += "<message>Document version approval info not found</message>";
			message += "<approval><enabled>0</enabled><hide>1</hide></approval>";
			message += "</status>";
			break done;
		}

		// Check if the project is in-active and disable approval if it is
		if (!ProjMgmntUtils.isProjectActive(response, session, curProject))	{
			message = "<status>" ;
			message += "<value>0</value>"; 
			message += "<message>Approval cannot be done as project status is not active</message>";
			message += "<approval><enabled>0</enabled><hide>1</hide>";
			message += "<approvalstate>" + docVersion.getApprovalStatus() + "</approvalstate>" ;
			message += "</approval>";
			message += "</status>";
			break done;		
		}
		
		// approval is not required, 
		// do not show the approval controls
		if (docVerInfo.getApprovalCycleState() == DocVersionApprovalInfo.ApprovalCycleStates.NO_RULE)
		{
			message = "<status>" ;
			message += "<value>0</value>"; 
			message += "<message>Approval is not required</message>";
			message += "<approval><enabled>0</enabled><hide>1</hide></approval>";
			message += "</status>";
			break done;			
		}
		
		// inquire additional properties used for the annotation permissions of document under approval 
		boolean isApprovalMaster=complexApprovalTM.isUserApprovalMaster(LoginID, UserID, DocVersionID);
		boolean isApproverAnyStage=false;
		
		try{
			// When the user is a non-PM user and the approval setup contains a one of role, this method will throw a permission denied error message. We catch this message and 
			isApproverAnyStage = complexApprovalTM.IsUserDocApproverInSetup(LoginID, UserID, DocVersionID);						
		} catch(Exception ex ){
			LogMgr.getLogger().log(Level.SEVERE, "Error: ComplexApprovalTM.IsUserDocApproverInSetup Details: " + ex.toString(), ex);
		}
		
		// when is stopped , 
		// do not show the approval controls, 
		// DO pass basic aprval role info for annotation checks
		if (docVerInfo.getApprovalCycleState() == DocVersionApprovalInfo.ApprovalCycleStates.STOPPED)
		{
			message = "<status>" ;
			message += "<value>0</value>"; 
			message += "<message>Approval is stopped</message>";
			message += "<approval><enabled>0</enabled><hide>1</hide>";
			if (isApprovalMaster) message += "<approvalmaster>1</approvalmaster>";
			if (isApproverAnyStage) message += "<approver>1</approver>";
			message += "</approval>";
			message += "</status>";
			break done;			
		}
		
		
		// if the user is not an approval user, and also not the PM or admin, 
		// we also do not show the approval controls 
		boolean userIsApprover = complexApprovalTM.IsUserDocApprover(LoginID, UserID, DocVersionID); 
		boolean userIsPM = false  ;  
		boolean userIsAdmin = false  ;  
		
		boolean enable = true ; 
		boolean hide  = false ; 
		boolean isPageList = false ;
		
		if ( ProjDetailsUtils.isUserProjectMgrByProjectID(response, session, ProjectID) )
		{
			userIsPM = true ;
		}
		if ( userTM.amIAdmin(LoginID) ) 
		{
			userIsAdmin	= true ;
		}
		
		// when the user is not an approval user, not the PM or not the admin, 
		// we can stop here  
		if ( !userIsApprover && !userIsPM &&  !userIsAdmin)
		{
			message = "<status>" ;
			message += "<value>0</value>"; 
			message += "<message>The user cannot submit his approval</message>";
			message += "<approval><enabled>0</enabled><hide>1</hide>";
			message += "<approvalstate>" + docVersion.getApprovalStatus() + "</approvalstate>" ;
			if (isApprovalMaster) message += "<approvalmaster>1</approvalmaster>";
			if (isApproverAnyStage) message += "<approver>1</approver>";
			message += "</approval>";
			message += "</status>";
			break done;			
		}
						
		// At this point, approval is required and the cycle is not stopped
		// Load the current approval stage to check the require review setting
		ComplexApprovalStage stage = complexApprovalTM.getOngoingApprovalStageByDocVersionId(LoginID, DocVersionID);
		int requireAnnotationReviewState = stage.getRequireReviewState();
		
		// Start building the message
		message  = "<status><value>0</value>";		
		message += "<approval>";		
		
		if (isApprovalMaster) message += "<approvalmaster>1</approvalmaster>";
		if (isApproverAnyStage) message += "<approver>1</approver>";
		if (requireAnnotationReviewState != ComplexApprovalStage.RequireReviewStateValues.NO) // 0: no annotation review required; this is the default
			message += "<requirereview>" + requireAnnotationReviewState + "</requirereview>";

		// Is a password needed for approval?
		if(ApprovalMgr.isApprovalPasswordRequired(session, response)) {
			message += "<validatepassword>1</validatepassword>";
		}
			

		// in case this is not a page list document, 
		// get the approval status of this document and for this user
		// else (if pagelist) - we already have the app status :-) 
		isPageList = docVersion.getDocTypeID().equalsIgnoreCase(DocTypeDB.DocTypeIDValues.PageList ) ;
		ApprovalStatus userApprovalStatus = null ;
		PageListUserApproval latestPageListUserApproval = null ;				
		if ( !isPageList  ) 
		{
			userApprovalStatus = new ApprovalStatus ();
			userApprovalStatus = approvalEJB.findApprovalStatusByUserId(LoginID, ProjectID, UserID, DocID, DocVersionID);				
		}
		else
		{
			PageListTM pagelistTM = DBTMUtils.findBean(response, session, PageListTM.class);
			int pagenr = 0 ;
			if (pageNumber!=null) 
				pagenr = new Integer(pageNumber).intValue() ;
			
			Vector approvalInfo = pagelistTM.loadPageListPageApprovalInfo(LoginID, DocVersionID, pagenr-docVersionOffset );
			if (approvalInfo== null) 
				appComment = "" ; 
			else
			{
				// get this user's approval comment
				for ( int i = 0 ; i < approvalInfo.size() ; i++ )
				{
					PageListUserApproval pageListUserApproval = (PageListUserApproval)approvalInfo.elementAt(i);
					if (pageListUserApproval.getUserID().equals(UserID) )
					{
						if (latestPageListUserApproval == null) 
						{
							latestPageListUserApproval = pageListUserApproval ;
						}
						else
						{
							// we have already an record for this user, check which one is most recent
							Timestamp existing = latestPageListUserApproval.getModTimeStamp();
							Timestamp newrecord = pageListUserApproval.getModTimeStamp() ;
							if ( existing.before(newrecord) )
							{
								latestPageListUserApproval = pageListUserApproval ;
							} 
						}
					} 					
				}
				if (latestPageListUserApproval != null ) 
					appComment = latestPageListUserApproval.getApprovalComment() ; 
			}
		}
		
				
		// two switches for the viewer : enable and hide
		// 'enable' indicates whether the approval controls are editabel 
		//          the controls are enabled when the user can make a change to the approval cycle
		// 'hide' indicates whether the approval controls are visibale
		//		 the controls are not visible when no approval cycle on a doc is ongoing, 
		// 		 or when the user is not an approval user on this document
		
		// for page list documents: for now, enable is on, hide is off 
		int pageNr = -1 ;
		if ( docVersion.getDocTypeID().equalsIgnoreCase(DocTypeDB.DocTypeIDValues.PageList ))
		{
			if (pageNumber!=null) 
				pageNr = new Integer(pageNumber).intValue() ;
			enable = ApprovalMgr.UserCanEditAppovalStatus(response, session, LoginID, UserID, ProjectID, DocID , DocVersionID, pageNr-docVersionOffset);			
		}	
		else{
			enable = ApprovalMgr.UserCanEditAppovalStatus(response, session, LoginID, UserID, ProjectID, DocID , DocVersionID, -1);			
		}

		
		// when the document is a page list document, and the page reached a final status, than the enable is false 
		if ( docVersion.getDocTypeID().equalsIgnoreCase(DocTypeDB.DocTypeIDValues.PageList ))
		{
			if (pageListPageProperties!=null)
			{
				String pageStatus = pageListPageProperties.getApprovalStatus();
				// when the status of the page is not pending, the page reached a final approval status 
				if (!pageStatus.equalsIgnoreCase(ApprovalStatusDB.ApprovalTypeIDValues.Pending ) )  
					enable 	= false ;
			} 
		}
		
			
		if ( docVersion.getDocTypeID().equalsIgnoreCase(DocTypeDB.DocTypeIDValues.PageList ))
		{
			if (latestPageListUserApproval!=null ) 
			{
				approvalTypeId = latestPageListUserApproval.getApprovalStatus();
				if (!enable)
				{
					appComment = latestPageListUserApproval.getApprovalComment(); 	
					if ( (appComment == null) || (appComment.length() == 0) ) 
					{
						appComment = "< " + LanguageMgr.getStr(UserLang, "APPROVAL_STATUS_FEEDBACK_NOCOMMENT" ) + " >" ;
					}
				} 										
			}
		}
		else
		{
			if ( (userApprovalStatus != null) && userApprovalStatus.isLoaded() )
			{	// Get the approval type
				approvalTypeId = userApprovalStatus.getApprovalStatus();
				if (!enable)
				{
					appComment = userApprovalStatus.getApprovalComment(); 	
					if ( (appComment == null) || (appComment.length() == 0) ) 
					{
						appComment = "< " + LanguageMgr.getStr(UserLang, "APPROVAL_STATUS_FEEDBACK_NOCOMMENT" ) + " >" ;
					}
				} 						
			}
		}
		
		
		// if the user can edit the status, than populate the appLevelsXMLwith possible statuses,
		// if the user cannot edit the status, the drop down box is only the last status 
		if ( enable )
		{
			// Set the possible approval levels for this user
			String appLevelsXML =  getApprovalLevelsXML(LoginID, UserID, ProjectID, DocID , DocVersionID, pageListPageProperties , UserLang, response, session, application) ;
			if (appLevelsXML != null ) 
				message  += appLevelsXML ;  
		}
		else
		{
			if ( approvalTypeId != null )
			{
				String appLevelsXML =  getUserApprovalLevelXML( UserLang, approvalTypeId, response, session) ;
				if (appLevelsXML != null ) 
					message  += appLevelsXML ;  
			} 			
			else 
			{
		
				if (docVerInfo!= null ) 
				{
					String approvalStatusID = docVerInfo.getApprovalState(); 
			
					// situation where the user is an approval user and he did not get a chance to submit his approval info
					// possible when the cycle got stopped, or when the PM did a force status 
					if (docVerInfo.getApprovalCycleState() == DocVersionApprovalInfo.ApprovalCycleStates.FINISHED )
					{
						appComment = getDocumentApprovalInfo( UserLang ,approvalStatusID, response, session) ;	
					}					
					else if ( docVerInfo.getApprovalCycleState() == DocVersionApprovalInfo.ApprovalCycleStates.STOPPED  ) 
					{	
						appComment = getApprovalCycleStoppedFeedBack( UserLang);					
					}
				}
			}
		} 

		// put the currect state in the message 
		message += "<approvalstate>" + docVersion.getApprovalStatus() + "</approvalstate>" ;
		
		if (appComment!= null) 
			message += "<approvalcomment>"+ toXML(appComment ) +"</approvalcomment>";
		
		// 	this is to tell the viewer to make the comments conditional
		message += "<useconditionalapproval>1</useconditionalapproval>";
					
		// put the hide and the enable flags in the message 		
		message += "<enabled>" + (enable?"1":"0") + "</enabled>";
		message += "<hide>" + (hide?"1":"0") + "</hide>";
		
		// close tags 		
		message += "</approval></status>" ;
		
		break done;
	}
	catch (Exception e) {
		errStr = "Exception: " + e.getMessage();
		break error;
	}
}
message = "<status><value>-1</value><message>" + errStr + "</message></status>";
}
System.out.println(message);
%>
<%=message%>

<%!
	public String GetTypeID(Vector approvalTypesList, String Typename)
	{
		for (int i = 0; i < approvalTypesList.size(); i++)
		{
			String typeName = ((ApprovalType)approvalTypesList.get(i)).getTypeName();
			if ( typeName.equals(Typename) )
				return ((ApprovalType)approvalTypesList.get(i)).getObjectID();
		}
		return null ;
	}
%>


<%! 
public String getApprovalCycleStoppedFeedBack(String  UserLang)
{
	String  strBuf = new String();
	String tempString = LanguageMgr.getStr(UserLang, "APPROVAL_FEEDBACK_CYCSTOPPED" ) ;
	if (tempString  != null ) 
		strBuf = (tempString); 
	strBuf += "\n" ;
	strBuf += ( LanguageMgr.getStr(UserLang, "APPROVAL_FEEDBACK_CANNOT SUBMIT_CYCLE_FINISHED" )) ;
	
	return  strBuf  ;
}
%>	



<%! 
public String getDocumentApprovalInfo( String UserLang, String appStatusID, HttpServletResponse response, HttpSession session) 
{	
	String  strBuf = new String();

	String tempString = LanguageMgr.getStr(UserLang, "APPROVAL_STATUS_FINISHEDCYCLE" ) ;

	if (tempString != null) 
		strBuf = (tempString ) + "\n" ;

	tempString = LanguageMgr.getStr(UserLang, "DOC_APPROVAL_STATUS" );
	strBuf += tempString  + ": \n" ;
	strBuf += "     ";

	String typeName_translated  = new String() ;
	Vector approvalTypesList =  ApprovalMgr.GetApprovalTypes(response, session);
	if ( approvalTypesList != null   )
	{
		for (int i = 0 ; i < approvalTypesList.size() ; i++)
		{
			ApprovalType appType = (ApprovalType) approvalTypesList.elementAt(i);
		
			if (appType.getObjectID().equals(appStatusID) ) 
			{
				String Label_tag = appType.getLabelTag() ;
				typeName_translated = LanguageMgr.getStr(UserLang, Label_tag ) ;			
			}			
		}
	}
	if (typeName_translated   != null )
	{
		strBuf += typeName_translated  ;
	} 
	strBuf += "\n";
	
	return   strBuf  ;	
}
%>

<%!
// write the list of approval choices in an xml string 
public String getUserApprovalLevelXML( String UserLang, String appStatusID, HttpServletResponse response, HttpSession session) 
{
	String appLevelsXML = new String ();
	
	appLevelsXML += "<approvaltypes>";

	Vector approvalTypesList =  ApprovalMgr.GetApprovalTypes(response, session);
	if ( (approvalTypesList != null )  )
	{
		for (int i = 0 ; i < approvalTypesList.size() ; i++)
		{
			ApprovalType appType = (ApprovalType) approvalTypesList.elementAt(i);
		
			if (appType.getObjectID().equals(appStatusID) ) 
			{
				String Label_tag = appType.getLabelTag() ;
				String typeName_translated = LanguageMgr.getStr(UserLang, Label_tag ) ;
			
				appLevelsXML += "<approvaltype>"+ 
					   "<approvalid>" + appType.getObjectID() + "</approvalid>" +
					   "<approvalname>" + toXML( typeName_translated ) + "</approvalname>"+ 
					   "</approvaltype>";			
			}			
		}
	}

	appLevelsXML += "</approvaltypes>";
	return appLevelsXML ;
}
%>

<%!
// write the list of approval choices in an xml string 
public String getApprovalLevelsXML(String LoginID,String  UserID,String  ProjectID, String DocID ,String  DocVersionID, PageListPageProperties pageListPageProperties, String UserLang, HttpServletResponse response, HttpSession session, ServletContext application) 
{
	String appLevelsXML = new String ();
	
		// run over the available types and put the status there that are applicable			
		appLevelsXML += "<approvaltypes>";
			
		// load list of available app statuses
		Vector approvalTypesList = ApprovalMgr.GetApprovalTypesForUser(response, session, application, LoginID, UserID, ProjectID, DocID , DocVersionID , pageListPageProperties);
			
		// put the possible statuses in the message 
		if ( approvalTypesList!= null )
		{
			//  BA00011038: when only forced approved/reject is possible, 
			//  add a "invite to select a status" item as the first item in the list 
			//  ( We cannot add more strings to the language file anymore for 6.2, that's why we indicate the empty state with '---', 
			//    ideally, it would be something like 'Change Status' or so...  )
			if (approvalTypesList.size() > 0)
			{
				boolean forcedOnly = true;
				for (int i = 0 ; i < approvalTypesList.size() ; i++ ) {
					ApprovalType appType = ((ApprovalType)approvalTypesList.elementAt(i));
					if (!appType.getTypeName().startsWith("FORCED")) { // not a very safe check, but OK in WCR 10.1 still
						forcedOnly = false;
						break;
					}
				}
				if (forcedOnly) {
					appLevelsXML += "<approvaltype>"+ 
						   "<approvalid>-1</approvalid>" +
						   "<approvalname>" + "---" + "</approvalname>"+ 
						   "</approvaltype>";								
				} 
			}
	
			for (int i = 0 ; i < approvalTypesList.size() ; i++ )
			{
				ApprovalType appType = (ApprovalType) approvalTypesList.elementAt(i);
				String Label_tag = appType.getLabelTag() ;
				String typeName_translated = LanguageMgr.getStr(UserLang, Label_tag ) ;
			
				appLevelsXML += "<approvaltype>"+ 
					   "<approvalid>" + appType.getObjectID() + "</approvalid>" +
					   "<approvalname>" + toXML( typeName_translated ) + "</approvalname>"+ 
					   "</approvaltype>";			
			}
		} 
		
	appLevelsXML += "</approvaltypes>";	
		
	return appLevelsXML ;
}
%>

<%!
	public static String toXML(String t) {
		StringBuffer b=new StringBuffer(t);
		int whitespace=0;
		for (int i=b.length()-1; i>=0; i--){
			char ch=b.charAt(i);
			switch (ch) {
				case '&':
					b.replace(i, i+1, "&amp;");
					break;
				case '<':
					b.replace(i, i+1, "&lt;");
					break;
				case '>':
					b.replace(i, i+1, "&gt;");
					break;
				case '"':
					b.replace(i, i+1, "&quot;");
					break;
				default:
					if (ch>127) {
						//String hex = new String("&#x" + Integer.toHexString(ch) + ";");
						String hex = new String("&#" + (int)ch + ";");
						b.replace(i, i+1, hex);
					}
					break;
			}
		}

		return b.toString();
	}  
%>
